AUI.Minimap.Pin = {}

local QUEST_PIN_SIZE = 32
local QUEST_AREA_MIN_SIZE = 18
local POI_PIN_SIZE = 40
local MAP_LOCATION_PIN_SIZE = 36
local PLAYER_PIN_SIZE = 16
local SMALL_KILL_LOCATION_SIZE = 16
local MEDIUM_KILL_LOCATION_SIZE = 20
local LARGE_KILL_LOCATION_SIZE = 24
local KEEP_PIN_SIZE = 53
local IMPERIAL_CITY_PIN_SIZE = 64
local ARTIFACT_PIN_SIZE = 64
local AVA_OBJECTIVE_SIZE = 16
local KEEP_RESOURCE_PIN_SIZE = 27
local KEEP_RESOURCE_MIN_SIZE = 24
local RESTRICTED_LINK_PIN_SIZE = 16

AUI_IC_PIN_POSITIONS = 
{
	{ .515175, .543171 },
	{ .557232, .336507 },
	{ .397913, .416717 },
}

AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND = 10000
AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD = 10002
AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT = 10003
AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD = 10004
AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT = 10005
AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND = 10006
AUI_MINIMAP_PIN_TYPE_GROUP_DEAD = 10007
AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT = 10008
AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT = 10009
AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD = 10010
AUI_MINIMAP_PIN_TYPE_POI_UNKNOWN = 10100
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION = 10195
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION = 10196
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING = 10197
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION = 10198
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION = 10199
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING = 10200
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY = 10201
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE = 10202
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY = 10203
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING = 10204	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE = 10205
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY = 10206	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS = 10207
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE = 10208
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY = 10209	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD = 10210
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE = 10211
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY = 10212
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON = 10213
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE = 10214
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY = 10215	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID = 10216
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE = 10217
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY = 10218	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP = 10219			
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE = 10220	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY = 10221
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY = 10222
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE = 10223	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY = 10224	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING = 10225
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE = 10226	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY = 10227	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS = 10228
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE = 10229
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY = 10230	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD = 10231
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE = 10232
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY = 10233	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON = 10234
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE = 10235
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY = 10236
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID = 10237	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE = 10238
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY = 10239
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP = 10240
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE = 10241			
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY = 10242	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY = 10243
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE = 10244
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY = 10245	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING = 10246	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE = 10247		
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY = 10248	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS = 10249	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE = 10250	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY = 10251		
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD = 10252
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE = 10253
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY = 10254	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON = 10255
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE = 10256	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY = 10257	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID = 10258
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE = 10259
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY = 10260
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP = 10261	
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE = 10262
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY = 10263	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY = 10264
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE = 10265	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY = 10266
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING = 10267
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE = 10268
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY = 10269	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS = 10270
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE = 10271	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY = 10272		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD = 10273	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE = 10274
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY = 10275	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON = 10276
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE = 10277
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY = 10278	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID = 10279		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE = 10280	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY = 10281		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP = 10282	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE = 10283
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY = 10284
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY = 10285
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE = 10286
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY = 10287
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING = 10288
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE = 10289	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY = 10290
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS = 10291
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE = 10292
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY = 10293	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD = 10294
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE = 10295
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY = 10296	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON = 10297
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE = 10298
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY = 10299
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID = 10300		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE = 10301
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY = 10302
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP = 10303					
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE = 10304		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY = 10305		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY = 10306	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE = 10307
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY = 10308
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING = 10309		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE = 10310
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY = 10311		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS = 10312
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE = 10313
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY = 10314
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD = 10315		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE = 10316	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY = 10317
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON = 10318
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE = 10319		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY = 10320	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID = 10321	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE = 10322	
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY = 10323		
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP = 10324
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE = 10325
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY = 10326

AUI_MINIMAP_UNIT_NORMAL = 0
AUI_MINIMAP_UNIT_IN_COMBAT = 2
AUI_MINIMAP_UNIT_DEAD = 1

local function GetPOIPinTexture(pin)
    return pin:GetPOIIcon()
end

local function GetPOIPinTint(pin)
    if pin and pin.IsLockedByLinkedCollectible and pin:IsLockedByLinkedCollectible() then
        return LOCKED_COLOR
    else
        return ZO_DEFAULT_ENABLED_COLOR
    end
end

local function GetLocationPinTexture(pin)
    return pin:GetLocationIcon()
end

local function GetFastTravelPinTextures(pin)
    return pin:GetFastTravelIcons()
end

local function GetQuestPinTexture(pin)
    return pin:GetQuestIcon()
end

local function GetGroupLeaderCombatTexture()
	local overlayTexture = "EsoUI/Art/Compass/groupLeader.dds"
	local highlightTexture = "EsoUI/Art/MapPins/ava_attackburst_32.dds"
	
	return overlayTexture, nil, highlightTexture
end

local function GetGroupLeaderDeadTexture()
	local overlayTexture = "EsoUI/Art/Compass/groupLeader.dds"
	local highlightTexture = "EsoUI/Art/MapPins/deathrecap_killingblow_icon.dds"
	
	return overlayTexture, nil, highlightTexture
end

local function GetGroupMemberCombatTexture()
	local overlayTexture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"
	local highlightTexture = "EsoUI/Art/MapPins/ava_attackburst_32.dds"
	
	return overlayTexture, nil, highlightTexture
end

local function GetGroupMemberDeadTexture()
	local overlayTexture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"
	local highlightTexture = "EsoUI/Art/MapPins/deathrecap_killingblow_icon.dds"
	
	return overlayTexture, nil, highlightTexture
end

AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION = 10195
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION = 10196
AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING = 10197
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION = 10198
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION = 10199
AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING = 10200

ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD] 		   			 				= { level = 2090, size = 32, texture = GetGroupLeaderDeadTexture}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD] 				    		 				= { level = 2080, size = 32, texture = GetGroupLeaderDeadTexture}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND] 				  			 			= { level = 2070, size = 32, texture = "EsoUI/Art/Compass/groupLeader.dds"}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT] 						 			= { level = 2060, size = 32, texture = GetGroupLeaderCombatTexture}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT] 				 				= { level = 2050, size = 32, texture = GetGroupLeaderCombatTexture}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD] 				    		 				= { level = 2040, size = 32, texture = GetGroupMemberDeadTexture}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND] 								 				= { level = 2030, size = 32, texture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_DEAD] 						    		 			= { level = 2020, size = 32, texture = GetGroupMemberDeadTexture}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT] 						 			= { level = 2010, size = 32, texture = GetGroupMemberCombatTexture}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT] 					    		 			= { level = 2000, size = 32, texture = GetGroupMemberCombatTexture}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION]   		 						= { level = 1360, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION]   		 				= { level = 1350, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING]   		 							= { level = 1340, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION]   		 							= { level = 1330, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION]   		 				= { level = 1320, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING]   									= { level = 1310, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY]   		 				= { level = 1600, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY]   		 					= { level = 1590, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE]   		 				= { level = 1580, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING]   		 				= { level = 1570, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY]   		 			= { level = 1560, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE]   			= { level = 1550, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS]   		 					= { level = 1540, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY]   		 			= { level = 1530, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE]   		 		= { level = 1520, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD]   		 					= { level = 1510, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY]   		 			= { level = 1500, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE]   		 		= { level = 1490, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON]   		 				= { level = 1480, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY]   		 			= { level = 1470, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE]   				= { level = 1460, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID]   		 					= { level = 1450, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY]   		 				= { level = 1440, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE]   		 		= { level = 1430, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP]   		 					= { level = 1420, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}				
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY]   		 			= { level = 1410, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE]   		 		= { level = 1400, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY]   				= { level = 1600, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY]   		 			= { level = 1590, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE]   		 	= { level = 1580, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING]   				= { level = 1570, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY]   		= { level = 1560, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE]   	= { level = 1550, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS]   		 			= { level = 1540, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY]   		 	= { level = 1530, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE]   		= { level = 1520, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD]   					= { level = 1510, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY]   			= { level = 1500, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE]   		= { level = 1490, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON]   				= { level = 1480, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY]   			= { level = 1470, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE]   	= { level = 1460, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID]   		 			= { level = 1450, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY]   		 	= { level = 1440, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE]   		= { level = 1430, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP]   					= { level = 1420, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}				
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY]   			= { level = 1410, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE]   		= { level = 1400, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY]   							= { level = 1600, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY]   		 						= { level = 1590, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE]   		 				= { level = 1580, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING]   		 					= { level = 1570, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY]   		 			= { level = 1560, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE]   				= { level = 1550, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS]   		 						= { level = 1540, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY]   		 				= { level = 1530, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE]   		 			= { level = 1520, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD]   		 						= { level = 1510, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY]   		 				= { level = 1500, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE]   		 			= { level = 1490, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON]   							= { level = 1480, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY]   						= { level = 1470, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE]   				= { level = 1460, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID]   		 						= { level = 1450, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY]   		 				= { level = 1440, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE]   		 			= { level = 1430, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP]   		 						= { level = 1420, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}				
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY]   		 				= { level = 1410, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE]   		 			= { level = 1400, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY]   						= { level = 1300, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY]   		 					= { level = 1290, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE]   		 				= { level = 1280, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING]   		 				= { level = 1270, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}                  
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY]   		 			= { level = 1260, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE]   				= { level = 1250, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS]   		 					= { level = 1240, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY]   		 				= { level = 1230, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE]   				= { level = 1220, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD]   		 					= { level = 1210, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY]   		 				= { level = 1200, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE]   		 		= { level = 1190, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON]   							= { level = 1180, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}                  
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY]   					= { level = 1170, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE]   				= { level = 1160, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID]   		 					= { level = 1150, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		           
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY]   		 				= { level = 1140, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE]   		 			= { level = 1130, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP]   		 					= { level = 1120, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY]   		 				= { level = 1110, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE]   		 		= { level = 1100, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY]   				= { level = 1300, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY]   		 			= { level = 1290, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE]   		 		= { level = 1280, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING]   		 		= { level = 1270, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		           
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY]   			= { level = 1260, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE]  		= { level = 1250, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS]   		 			= { level = 1240, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}                  
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY]   			= { level = 1230, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE]   		= { level = 1220, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD]   		 			= { level = 1210, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		           
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY]   			= { level = 1200, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE]   		= { level = 1190, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON]   				= { level = 1180, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}                  
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY]   			= { level = 1170, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE]  		= { level = 1160, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID]   		 			= { level = 1150, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY]   				= { level = 1140, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE]   		= { level = 1130, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP]   		 			= { level = 1120, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY]   			= { level = 1110, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE]   		= { level = 1100, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY]   							= { level = 1300, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY]   		 						= { level = 1290, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE]   		 					= { level = 1280, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING]   		 					= { level = 1270, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		           
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY]   		 				= { level = 1260, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE]   		 		= { level = 1250, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS]   		 						= { level = 1240, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}                  
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY]   		 				= { level = 1230, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE]   		 			= { level = 1220, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD]   		 						= { level = 1210, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}		           
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY]   		 				= { level = 1200, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE]   		 			= { level = 1190, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON]   							= { level = 1180, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}                  
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY]   						= { level = 1170, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE]   					= { level = 1160, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID]   		 						= { level = 1150, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY]   		 					= { level = 1140, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE]   		 			= { level = 1130, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP]   		 						= { level = 1120, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}	               
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY]   		 				= { level = 1110, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE]   		 			= { level = 1100, size = QUEST_PIN_SIZE, minAreaSize = QUEST_AREA_MIN_SIZE, texture = GetQuestPinTexture, insetX = 7, insetY = 4}
ZO_MapPin.PIN_DATA[AUI_MINIMAP_PIN_TYPE_POI_UNKNOWN]                      							= { level = 10, size = POI_PIN_SIZE, texture = "AUI/images/minimap/unknown-pin.dds"}
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_DEAD] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT] = true
ZO_MapPin.UNIT_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT] = true
ZO_MapPin.GROUP_LEADER_PIN_TYPES = {}
ZO_MapPin.GROUP_LEADER_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND] = true
ZO_MapPin.GROUP_LEADER_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT] = true
ZO_MapPin.GROUP_LEADER_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT] = true
ZO_MapPin.GROUP_LEADER_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD] = true
ZO_MapPin.GROUP_LEADER_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_DEAD] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT] = true
ZO_MapPin.GROUP_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT] = true
ZO_MapPin.POI_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_POI_UNKNOWN] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = true		
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP] = true		
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY] = true	
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = true
ZO_MapPin.QUEST_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = true		
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE] = true	
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE] = true
ZO_MapPin.ASSISTED_PIN_TYPES[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY] = true

AUI_MINIMAP_ALLIANCE_TO_RESTRICTED_PIN_TYPE = {
	[ALLIANCE_ALDMERI_DOMINION] = MAP_PIN_TYPE_RESTRICTED_LINK_ALDMERI_DOMINION,
	[ALLIANCE_EBONHEART_PACT] = MAP_PIN_TYPE_RESTRICTED_LINK_EBONHEART_PACT,
	[ALLIANCE_DAGGERFALL_COVENANT] = MAP_PIN_TYPE_RESTRICTED_LINK_DAGGERFALL_COVENANT,
}

AUI_MINIMAP_QUEST_PIN_TEXTURES = {
	[MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING] = "EsoUI/Art/Compass/repeatableQuest_icon_assisted.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING] = "EsoUI/Art/Compass/repeatableQuest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",		
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon.dds",					
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_QUEST_REPEATABLE_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon.dds",
	[MAP_PIN_TYPE_QUEST_REPEATABLE_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon.dds",
	[MAP_PIN_TYPE_QUEST_REPEATABLE_ENDING] = "EsoUI/Art/Compass/repeatableQuest_icon.dds",
}

AUI_MINIMAP_BREADCRUMB_QUEST_PIN_TEXTURES = 
{
	[MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING] = "EsoUI/Art/Compass/repeatableQuest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING] = "EsoUI/Art/Compass/repeatableQuest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",			
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",		
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",		
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP] = "EsoUI/Art/Compass/quest_icon_door.dds",					
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",		
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",	
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_QUEST_REPEATABLE_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_door.dds",
	[MAP_PIN_TYPE_QUEST_REPEATABLE_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/repeatableQuest_icon_door.dds",
	[MAP_PIN_TYPE_QUEST_REPEATABLE_ENDING] = "EsoUI/Art/Compass/repeatableQuest_icon_door.dds",
}	

function AUI.Minimap.Pin.GetQuestPinType(pinType, questType, questRepeatType)
	if not AUI.Minimap.IsLoaded() then
		return
	end

	if questType == QUEST_TYPE_MAIN_STORY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY						
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY				
		end
	elseif questType == QUEST_TYPE_NONE and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY			
		end	
	elseif questType == QUEST_TYPE_CRAFTING and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY		
		end	
	elseif questType == QUEST_TYPE_CLASS and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY		
		end	
	elseif questType == QUEST_TYPE_GUILD and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY		
		end	
	elseif questType == QUEST_TYPE_DUNGEON and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY		
		end	
	elseif questType == QUEST_TYPE_RAID and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY		
		end	
	elseif questType == QUEST_TYPE_GROUP and questRepeatType == QUEST_REPEAT_DAILY then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY	
		end
	elseif questType == QUEST_TYPE_NONE and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_CRAFTING and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_CLASS and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_GUILD and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE	
		end	
	elseif questType == QUEST_TYPE_DUNGEON and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE	
		end	
	elseif questType == QUEST_TYPE_RAID and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE		
		end	
	elseif questType == QUEST_TYPE_GROUP and questRepeatType == QUEST_REPEAT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_REPEATABLE_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE	
		end

	elseif questType == QUEST_TYPE_NONE and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION					
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING	
		end	
	elseif questType == QUEST_TYPE_CRAFTING and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING	
		end	
	elseif questType == QUEST_TYPE_CLASS and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS				
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS		
		end	
	elseif questType == QUEST_TYPE_GUILD and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD			
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD	
		end	
	elseif questType == QUEST_TYPE_DUNGEON and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON
		end	
	elseif questType == QUEST_TYPE_RAID and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID	
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID		
		end	
	elseif questType == QUEST_TYPE_GROUP and questRepeatType == QUEST_REPEAT_NOT_REPEATABLE then
		if pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP
		elseif pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP		
		elseif pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
			pinType = AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP	
		end		
	end	

	return pinType
end

local function AUI_MapPin_GetUnitState(pinTag)
	local groupSize = GetGroupSize()
	
	local unitTag = nil
	for i=1, groupSize do
		unitTag = GetGroupUnitTagByIndex(i)	
		
		if unitTag == pinTag then	
			if IsUnitDead(unitTag) == true then
				return AUI_MINIMAP_UNIT_DEAD, IsUnitFriend(unitTag) 
			elseif IsUnitInCombat(unitTag) == true then
				return AUI_MINIMAP_UNIT_IN_COMBAT, IsUnitFriend(unitTag) 
			end
			break
		end
	end

	return AUI_MINIMAP_UNIT_NORMAL, IsUnitFriend(unitTag) 
end

function AUI.Minimap.Pin.GetGroupStatePinType(groupTag)
	local pinType = MAP_PIN_TYPE_GROUP
			
	if groupTag then
		local isLeader = IsUnitGroupLeader(groupTag)
		local unitState, isFriend = AUI_MapPin_GetUnitState(groupTag)

		if isLeader then
			if unitState == AUI_MINIMAP_UNIT_IN_COMBAT and AUI.Settings.Minimap.showGroupMemberStatus then	
				if isFriend then
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT				
				else					
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT
				end
			elseif unitState == AUI_MINIMAP_UNIT_DEAD and AUI.Settings.Minimap.showGroupMemberStatus then	
				if isFriend then
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD				
				else					
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_DEAD
				end
			elseif unitState == AUI_MINIMAP_UNIT_NORMAL or not AUI.Settings.Minimap.showGroupMemberStatus then
				if isFriend then
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND				
				else					
					pinType = MAP_PIN_TYPE_GROUP_LEADER
				end					
			end
		else
			if unitState == AUI_MINIMAP_UNIT_IN_COMBAT and AUI.Settings.Minimap.showGroupMemberStatus then	
				if isFriend then
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT				
				else					
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT
				end
			elseif unitState == AUI_MINIMAP_UNIT_DEAD and AUI.Settings.Minimap.showGroupMemberStatus then	
				if isFriend then
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD				
				else					
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_DEAD
				end									
			elseif unitState == AUI_MINIMAP_UNIT_NORMAL or not AUI.Settings.Minimap.showGroupMemberStatus then
				if isFriend then
					pinType = AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND				
				else					
					pinType = MAP_PIN_TYPE_GROUP
				end					
			end
		end
	end

	return pinType
end

local function AUI_Minimap_SetIconThemeData(iconThemeData, pinData)
	if pinData and iconThemeData then	
		local overlayTexture = iconThemeData["Overlay_Texture"]
		local pulseTexture = iconThemeData["Pulse_Texture"]
		local backgroundTexture = iconThemeData["Background_Texture"]	
			
		if overlayTexture and pulseTexture and backgroundTexture then		
			pinData.texture = function() return overlayTexture, pulseTexture, backgroundTexture end
		elseif overlayTexture and backgroundTexture and not pulseTexture then
			pinData.texture = function() return overlayTexture, nil, backgroundTexture end
		elseif overlayTexture and pulseTexture and not backgroundTexture then
			pinData.texture = function() return overlayTexture, pulseTexture, nil end	
		elseif overlayTexture then
			pinData.texture = function() return overlayTexture, nil, nil end		
		end	
			
		local color = iconThemeData["Color"]
	
		if color then
			pinData.tint = AUI.Color.ConvertHexToRGBA(color)
		end
	
		local isAnimated = iconThemeData["IsAnimated"]
	
		if color then
			pinData.isAnimated = isAnimated
		end
	end			
end

function AUI.Minimap.Pin.SetPinData()
	for pinType, pinData in pairs(ZO_MapPin.PIN_DATA) do
		if pinType == MAP_PIN_TYPE_PLAYER then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_player_color)
				ZO_MapPin.PIN_DATA[pinType].level = 3000
		elseif pinType == MAP_PIN_TYPE_GROUP_LEADER then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_normal_color)
		elseif pinType == MAP_PIN_TYPE_GROUP then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_normal_color)		
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_IN_COMBAT then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_combat_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_DEAD then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_dead_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_friend_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_IN_COMBAT then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_friend_combat_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_LEADER_FRIEND_DEAD then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_leader_friend_dead_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_IN_COMBAT then				
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_combat_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_DEAD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_dead_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND then				
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_friend_normal_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_IN_COMBAT then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_friend_combat_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_GROUP_FRIEND_DEAD then			
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_group_member_friend_dead_color)			
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)			
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_MAINSTORY then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CRAFTING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_CLASS_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)										
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GUILD_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_DUNGEON_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)										
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_RAID_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_CONDITION_GROUP_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_MAINSTORY then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)							
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)		
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_MAINSTORY then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CRAFTING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_CLASS_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GUILD_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_DUNGEON_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_RAID_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_ASSISTED_QUEST_ENDING_GROUP_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)	
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_MAINSTORY then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CRAFTING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_CLASS_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GUILD_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_DUNGEON_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)										
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_RAID_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_CONDITION_GROUP_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)			
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_MAINSTORY then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)			
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CRAFTING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)							
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_CLASS_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GUILD_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_DUNGEON_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_RAID_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION_GROUP_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_MAINSTORY then	
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_mainstory_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)				
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CRAFTING_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_CLASS_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GUILD_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_DUNGEON_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)									
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_RAID_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)								
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP then		
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_normal_color)
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_DAILY then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_daily_color)					
		elseif pinType == AUI_MINIMAP_PIN_TYPE_TRACKED_QUEST_ENDING_GROUP_REPEATABLE then
				ZO_MapPin.PIN_DATA[pinType].tint = AUI.Color.GetColorDefFromNamedRGBA(AUI.Settings.Minimap.pin_quest_repeatable_color)			
		end

		local iconTheme = AUI.Minimap.Theme.GetCurrentMiniMapIconTheme()
		
		if iconTheme and AUI.Settings.Minimap.icon_theme ~= "default" then
			local iconThemeData = iconTheme[pinType]

			if iconThemeData then
				AUI_Minimap_SetIconThemeData(iconThemeData, ZO_MapPin.PIN_DATA[pinType])
			end	
		end		
	end	
end